package rtdt_benchmark

import (
	"encoding/json"
	"fmt"
	"os"
	"time"
)

type Rtdt_Benchmark struct {
	MneGnmiRcv  time.Time
	MneGnmiSend time.Time
}

var CurrentBenchmark Rtdt_Benchmark

func AppendToJsonFile(r *Rtdt_Benchmark) {
	var benchmarks []Rtdt_Benchmark
	if _, err := os.Stat("/etc/gnmi-target/mne_share/measure_mne.json"); err == nil {
		data, err := os.ReadFile("/etc/gnmi-target/mne_share/measure_mne.json")
		if err != nil {
			fmt.Println("Error reading file:", err)
			return
		}
		if len(data) > 0 {
			err = json.Unmarshal(data, &benchmarks)
			if err != nil {
				fmt.Println("Error unmarshaling JSON:", err)
				return
			}
		}
	} else if !os.IsNotExist(err) {
		fmt.Println("Error checking file status:", err)
		return
	}

	// Append the new benchmark
	benchmarks = append(benchmarks, *r)

	// Marshal and write back to file
	outData, err := json.MarshalIndent(benchmarks, "", "  ")
	if err != nil {
		fmt.Println("Error marshaling JSON:", err)
		return
	}

	err = os.WriteFile("/etc/gnmi-target/mne_share/measure_mne.json", outData, 0644)
	if err != nil {
		fmt.Println("Error writing to file:", err)
	}
}
