ARG GOLANG_VERSION=1.23
ARG GITLAB_PROXY
ARG BUILDARGS

FROM ${GITLAB_PROXY}golang:$GOLANG_VERSION-bookworm as builder
WORKDIR /gnmi-target/
COPY . .
RUN --mount=type=cache,target=/root/go/pkg/mod \
    --mount=type=cache,target=/root/.cache/go-build \
    make build

FROM ${GITLAB_PROXY}ubuntu:22.04 as ubuntu
RUN apt-get update && apt-get upgrade -y && apt-get install -y \
    iproute2 \
    iputils-ping \
    openssh-client \
    openssh-server \
    libssl-dev

COPY --from=builder gnmi-target/artifacts/gnmi-target /usr/bin/gnmi-target
EXPOSE 7030
ENTRYPOINT ["/usr/bin/gnmi-target"]
CMD [ "start", "--log", "debug" ]

FROM ${GITLAB_PROXY}debian:bookworm as debian
RUN apt-get update && apt-get upgrade -y && apt-get install -y \
    iproute2 \
    iputils-ping \
    openssh-client \
    openssh-server \
    libssl-dev

COPY --from=builder gnmi-target/artifacts/gnmi-target /usr/bin/gnmi-target
EXPOSE 7030
ENTRYPOINT ["/usr/bin/gnmi-target"]
CMD [ "start", "--log", "debug" ]
